=== debian/changelog ===
gsad (24.5.4-2) unstable; urgency=medium

  * Update debian/watch to version 5

 -- Sophie Brun <sophie@kali.org>  Fri, 03 Oct 2025 16:20:29 +0200

gsad (24.5.4-1) unstable; urgency=medium

  * New upstream version 24.5.4
  * debian/copyright: Fix old fsf address

 -- Sophie Brun <sophie@kali.org>  Mon, 25 Aug 2025 11:57:40 +0200

gsad (24.5.3-1) unstable; urgency=medium

  * New upstream version 24.5.3
  * Update my email

 -- Sophie Brun <sophie@kali.org>  Thu, 14 Aug 2025 15:14:53 +0200
