=== debian/control ===
Source: gsad
Section: admin
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Sophie Brun <sophie@kali.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
	       clang-format,
	       cppcheck,
               libmicrohttpd-dev,
               libgvm-dev (>= 22.8.0),
               libxslt1-dev,
               doxygen,
	       xmltoman,
               pkgconf,
               libxml2-dev
Standards-Version: 4.7.2
Homepage: https://www.greenbone.net
Vcs-Git: https://salsa.debian.org/pkg-security-team/gsad.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/gsad

Package: gsad
Architecture: any
Depends: gvmd (>= 22.5.0),
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: greenbone-security-assistant (>= 22.4.0)
Replaces: greenbone-security-assistant (<< 21.4.4)
Breaks: greenbone-security-assistant (<< 21.4.4)
Description: remote network security auditor - web interface
 The Greenbone Security Assistant HTTP Server connects to the Greebone
 Vulnerability Manager "gvmd" to provide a full-featured user interface for
 vulnerability management.
 .
 This tools was initially provided by the package greenbone-security-assistant.
