=== debian/watch ===
version: 5
Template: Github
Owner: greenbone
Project: gsad
