## gsad 24.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 
 message("-- Configuring gsad")
 
-project(gsad VERSION 24.5.4 LANGUAGES C)
+project(gsad VERSION 24.7.0 LANGUAGES C)
 
 if(NOT DEFINED PROJECT_VERSION_STRING)
   set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
@@ -34,13 +34,24 @@
 
 if(NOT ENABLE_AGENTS)
   set(ENABLE_AGENTS 0)
+else(NOT ENABLE_AGENTS)
+  message(STATUS "Building with agents feature enabled")
 endif(NOT ENABLE_AGENTS)
 add_definitions(-DENABLE_AGENTS=${ENABLE_AGENTS})
 
 if(NOT ENABLE_CONTAINER_SCANNING)
   set(ENABLE_CONTAINER_SCANNING 0)
+else(NOT ENABLE_CONTAINER_SCANNING)
+  message(STATUS "Building with container image scanning feature enabled")
 endif(NOT ENABLE_CONTAINER_SCANNING)
 add_definitions(-DENABLE_CONTAINER_SCANNING=${ENABLE_CONTAINER_SCANNING})
+
+if(NOT ENABLE_CREDENTIAL_STORES)
+  set(ENABLE_CREDENTIAL_STORES 0)
+else(NOT ENABLE_CREDENTIAL_STORES)
+  message(STATUS "Building with credential stores feature enabled")
+endif(NOT ENABLE_CREDENTIAL_STORES)
+add_definitions(-DENABLE_CREDENTIAL_STORES=${ENABLE_CREDENTIAL_STORES})
 
 ## Code coverage
