=== debian/changelog ===
gsad (24.7.0-1) unstable; urgency=medium

  * New upstream version 24.7.0
  * Fix typo in debian/watch

 -- Sophie Brun <sophie@kali.org>  Thu, 06 Nov 2025 09:56:25 +0100
