=== debian/changelog ===
gsad (24.12.0-1) unstable; urgency=medium

  * New upstream version 24.12.0

 -- Sophie Brun <sophie@kali.org>  Fri, 05 Dec 2025 11:35:47 +0100
