=== debian/changelog ===
gsad (24.12.2-1) unstable; urgency=medium

  * New upstream version 24.12.2

 -- Sophie Brun <sophie@kali.org>  Thu, 08 Jan 2026 10:47:13 +0100
